# `CodecPipeline`

digraph inheritance9b2c7a8dd0 { bgcolor=transparent; rankdir=UD; ratio=compress; size="8.0, 12.0"; "Codec" [URL="taurus.core.util.codecs-Codec.html#taurus.core.util.codecs.Codec",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="The base class for all codecs"]; "Logger" -> "Codec" [arrowsize=0.5,style="setlinewidth(0.5)"]; "CodecPipeline" [URL="#taurus.core.util.codecs.CodecPipeline",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="The codec class used when encoding/decoding data with multiple encoders"]; "Codec" -> "CodecPipeline" [arrowsize=0.5,style="setlinewidth(0.5)"]; "Logger" [URL="taurus-Logger.html#taurus.Logger",color=dodgerblue1,fillcolor=white,fontcolor=black,fontname="Vera Sans, DejaVu Sans, Liberation Sans, Arial, Helvetica, sans",fontsize=10,height=0.5,shape=box,style=rounded,target="_top",tooltip="The taurus logger class. All taurus pertinent classes should inherit"]; }

class CodecPipeline(format)

  The codec class used when encoding/decoding data with multiple encoders

  Example usage:

      >>> from taurus.core.util.codecs import CodecPipeline

      >>> data = range(100000)
      >>> codec = CodecPipeline('bz2_json')
      >>> format, encoded_data = codec.encode(("", data))

      # decode it
      format, decoded_data = codec.decode((format, encoded_data))
      print(decoded_data)

  Import from `taurus.core.util.codecs` as:

      from taurus.core.util.codecs import CodecPipeline

  decode(data, *args, **kwargs)

    decodes the given data.

    Parameters:

      data (sequence[str, obj]) – a sequence of two elements where the first item is the encoding format of the second item object

    Returns:

      a sequence of two elements where the first item is the encoding format of the second item object

    Return type:

      sequence[str, obj]

  encode(data, *args, **kwargs)

    encodes the given data.

    Parameters:

      data (sequence[str, obj]) – a sequence of two elements where the first item is the encoding format of the second item object

    Returns:

      a sequence of two elements where the first item is the encoding format of the second item object

    Return type:

      sequence[str, obj]